unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    OpenDialog1: TOpenDialog;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Panel1: TPanel;
    Button1: TButton;
    Button2: TButton;
    Edit1: TEdit;
    UpDown1: TUpDown;
    Memo1: TMemo;
    Panel2: TPanel;
    Button3: TButton;
    Memo2: TMemo;
    Edit2: TEdit;
    UpDown2: TUpDown;
    Button4: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    procedure ShowSizeAndTick(const Size, Tick: Int64);
    procedure ShowModifiedAndTick(const Modified: TDateTime; const Tick: Int64);
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

//  ---------------------------------------------------------------------------
//  t@CTCY擾(TFileStream)
function FileSizeByFileStream(const FileName: string): Int64;
begin
    Result := -1;
    try
        with TFileStream.Create(FileName, fmOpenRead, fmShareDenyNone) do
        begin
            try
                Result := Size;
            finally
                Free;
            end;
        end;
    except
    end;
end;

//  ---------------------------------------------------------------------------
//  t@CTCY擾(TSearchRec)
function FileSizeBySearchRec(const FileName: string): Int64;
var
    SR: TSearchRec;
begin
    Result := -1;
    try
        if FindFirst(FileName, faAnyFile, SR) = 0 then
        begin
            try
                Result := SR.Size;
            finally
                FindClose(SR);
            end;
        end;
    except
    end;
end;

//  ---------------------------------------------------------------------------
//  t@CTCY擾(FileSize)
function FileSizeByFileSize(const FileName: string): Int64;
var
    F: file;                            //  ^Ȃt@C
begin
    Result := -1;
    try
        AssignFile(F, FileName);
        try
            Reset(F, 1);                //  oCgt@C
            Result := FileSize(F);
        finally
            CloseFile(F);
        end;
    except
    end;
end;

//  ---------------------------------------------------------------------------
//  \
procedure TForm1.ShowSizeAndTick(const Size, Tick: Int64);
begin
    Memo1.Lines.Add(Format('%s (%d msec)', [FormatFloat('#,##0 byte', Size), Tick]));
end;

//  ---------------------------------------------------------------------------
//  t@CTCY擾eXg
procedure TForm1.Button1Click(Sender: TObject);
var
    TickCount: Cardinal;
    Size: Int64;
    FileName: string;
begin
    //  t@CIĂ炤
    if (not OpenDialog1.Execute) then Exit;
    FileName := OpenDialog1.FileName;

    //  J[\ύX
    Screen.Cursor := crHourGlass;

    //  -------------------------------------------------------------
    //  @1
    Memo1.Lines.Add('===============================================');
    Memo1.Lines.Add('1  TFileStream.Size');
    //  ԌvJn
    TickCount := GetTickCount;
    //  s
    Size := FileSizeByFileStream(FileName);
    //  ԌvI
    ShowSizeAndTick(Size, GetTickCount - TickCount);

    //  -------------------------------------------------------------
    //  @2
    Memo1.Lines.Add('===============================================');
    Memo1.Lines.Add('2  FindFirst & TSearchRec.Size');
    //  ԌvJn
    TickCount := GetTickCount;
    //  s
    Size := FileSizeBySearchRec(FileName);
    //  ԌvI
    ShowSizeAndTick(Size, GetTickCount - TickCount);

    //  -------------------------------------------------------------
    //  @3
    Memo1.Lines.Add('===============================================');
    Memo1.Lines.Add('3  ^Ȃt@CƂ FileSize');
    //  ԌvJn
    TickCount := GetTickCount;
    //  s
    Size := FileSizeByFileSize(FileName);
    //  ԌvI
    ShowSizeAndTick(Size, GetTickCount - TickCount);

    //  J[\߂
    Screen.Cursor := crDefault;
end;

//  ---------------------------------------------------------------------------
//  t@CTCY擾eXg - 2
procedure TForm1.Button2Click(Sender: TObject);
var
    i, TEST_COUNT: integer;
    TickCount: Cardinal;
    Size: Int64;
    FileName: string;
begin
    //  t@CIĂ炤
    if (not OpenDialog1.Execute) then Exit;
    FileName := OpenDialog1.FileName;

    //  s񐔎擾
    TEST_COUNT := UpDown1.Position;

    //  J[\ύX
    Screen.Cursor := crHourGlass;

    //  -------------------------------------------------------------
    //  @3
    Memo1.Lines.Add('===============================================');
    Memo1.Lines.Add('3  ^Ȃt@CƂ FileSize');
    //  ԌvJn
    TickCount := GetTickCount;
    //  s
    Size := -1;
    for i := 0 to TEST_COUNT - 1 do
    begin
        Size := FileSizeByFileSize(FileName);
    end;
    //  ԌvI
    ShowSizeAndTick(Size, GetTickCount - TickCount);

    //  -------------------------------------------------------------
    //  @2
    Memo1.Lines.Add('===============================================');
    Memo1.Lines.Add('2  FindFirst & TSearchRec.Size');
    //  ԌvJn
    TickCount := GetTickCount;
    //  s
    Size := -1;
    for i := 0 to TEST_COUNT - 1 do
    begin
        Size := FileSizeBySearchRec(FileName);
    end;
    //  ԌvI
    ShowSizeAndTick(Size, GetTickCount - TickCount);

    //  -------------------------------------------------------------
    //  @1
    Memo1.Lines.Add('===============================================');
    Memo1.Lines.Add('1  TFileStream.Size');
    //  ԌvJn
    TickCount := GetTickCount;
    //  s
    Size := -1;
    for i := 0 to TEST_COUNT - 1 do
    begin
        Size := FileSizeByFileStream(FileName);
    end;
    //  ԌvI
    ShowSizeAndTick(Size, GetTickCount - TickCount);

    //  J[\߂
    Screen.Cursor := crDefault;
end;

//  ---------------------------------------------------------------------------
//  ŏIXV擾(FileAge)
//  http://hp.vector.co.jp/authors/VA009712/take/delphi/kabesys.htm#datetimefile1
function FileModifiedByFileAge(const FileName: string): TDateTime;
begin
    Result := FileDateToDateTime(FileAge(FileName));
end;

//  ---------------------------------------------------------------------------
//  ŏIXV擾(GetFileTime)
//  http://hp.vector.co.jp/authors/VA009712/take/delphi/kabesys.htm#datetimefile2
function FileModifiedByGetFileTime(const FileName: string): TDateTime;
var
    FileHandle: integer;
    ftCreateDate: TFileTime;
    ftModifyDate: TFileTime;
    ftAccessDate: TFileTime;
    lftModifyDate: TFileTime;
    stModifyDate: TSystemTime;
begin
    Result := 0;
    try
        FileHandle := FileOpen(FileName, fmOpenRead or fmShareDenyNone);
        if (FileHandle >= 0) then
        begin
            try
                //  t@C̓擾
                GetFileTime(FileHandle, @ftCreateDate, @ftAccessDate, @ftModifyDate);
                //  [JɕύX
                FileTimeToLocalFileTime(ftModifyDate, lftModifyDate);
                //  VXeɕύX
                FileTimeToSystemTime(lftModifyDate, stModifyDate);
                Result := SystemTimeToDateTime(stModifyDate);
            finally
                FileClose(FileHandle);
            end;
        end;
    except
    end;
end;

//  ---------------------------------------------------------------------------
//  ŏIXV擾(FileGetDate)
//  http://hp.vector.co.jp/authors/VA009712/take/delphi/kabesys.htm#datetimefile1
function FileModifiedByFileGetDate(const FileName: string): TDateTime;
var
    FileHandle: integer;
begin
    Result := 0;
    try
        FileHandle := FileOpen(FileName, fmOpenRead or fmShareDenyNone);
        if (FileHandle >= 0) then
        begin
            try
                Result := FileDateToDateTime(FileGetDate(FileHandle));
            finally
                FileClose(FileHandle);
            end;
        end;
    except
    end;
end;

//  ---------------------------------------------------------------------------
//  \
procedure TForm1.ShowModifiedAndTick(const Modified: TDateTime; const Tick: Int64);
begin
    Memo2.Lines.Add(Format('%s (%d msec)',
                    [FormatDateTime('yyyy/mm/dd hh:nn:ss:zzz', Modified), Tick]));
end;

//  ---------------------------------------------------------------------------
//  ŏIXV擾eXg - 1
procedure TForm1.Button3Click(Sender: TObject);
var
    TickCount: Cardinal;
    Modified: TDateTime;
    FileName: string;
begin
    //  t@CIĂ炤
    if (not OpenDialog1.Execute) then Exit;
    FileName := OpenDialog1.FileName;

    //  J[\ύX
    Screen.Cursor := crHourGlass;

    //  -------------------------------------------------------------
    //  @1
    Memo2.Lines.Add('===============================================');
    Memo2.Lines.Add('1  FileAge');
    //  ԌvJn
    TickCount := GetTickCount;
    //  s
    Modified := FileModifiedByFileAge(FileName);
    //  ԌvI
    ShowModifiedAndTick(Modified, GetTickCount - TickCount);

    //  -------------------------------------------------------------
    //  @2
    Memo2.Lines.Add('===============================================');
    Memo2.Lines.Add('2  GetFileTime');
    //  ԌvJn
    TickCount := GetTickCount;
    //  s
    Modified := FileModifiedByGetFileTime(FileName);
    //  ԌvI
    ShowModifiedAndTick(Modified, GetTickCount - TickCount);

    //  -------------------------------------------------------------
    //  @3
    Memo2.Lines.Add('===============================================');
    Memo2.Lines.Add('3  FileGetDate');
    //  ԌvJn
    TickCount := GetTickCount;
    //  s
    Modified := FileModifiedByFileGetDate(FileName);
    //  ԌvI
    ShowModifiedAndTick(Modified, GetTickCount - TickCount);

    //  J[\߂
    Screen.Cursor := crDefault;
end;

//  ---------------------------------------------------------------------------
//  ŏIXV擾eXg - 2
procedure TForm1.Button4Click(Sender: TObject);
var
    i, TEST_COUNT: integer;
    TickCount: Cardinal;
    Modified: TDateTime;
    FileName: string;
begin
    //  t@CIĂ炤
    if (not OpenDialog1.Execute) then Exit;
    FileName := OpenDialog1.FileName;

    //  s񐔎擾
    TEST_COUNT := UpDown2.Position;

    //  J[\ύX
    Screen.Cursor := crHourGlass;

    //  -------------------------------------------------------------
    //  @3
    Memo2.Lines.Add('===============================================');
    Memo2.Lines.Add('1  FileAge');
    //  ԌvJn
    TickCount := GetTickCount;
    //  s
    Modified := 0;
    for i := 0 to TEST_COUNT - 1 do
    begin
        Modified := FileModifiedByFileAge(FileName);
    end;
    //  ԌvI
    ShowModifiedAndTick(Modified, GetTickCount - TickCount);

    //  -------------------------------------------------------------
    //  @2
    Memo2.Lines.Add('===============================================');
    Memo2.Lines.Add('2  GetFileTime');
    //  ԌvJn
    TickCount := GetTickCount;
    //  s
    Modified := 0;
    for i := 0 to TEST_COUNT - 1 do
    begin
        Modified := FileModifiedByGetFileTime(FileName);
    end;
    //  ԌvI
    ShowModifiedAndTick(Modified, GetTickCount - TickCount);

    //  -------------------------------------------------------------
    //  @1
    Memo2.Lines.Add('===============================================');
    Memo2.Lines.Add('3  FileGetDate');
    //  ԌvJn
    TickCount := GetTickCount;
    //  s
    Modified := 0;
    for i := 0 to TEST_COUNT - 1 do
    begin
        Modified := FileModifiedByFileGetDate(FileName);
    end;
    //  ԌvI
    ShowModifiedAndTick(Modified, GetTickCount - TickCount);

    //  J[\߂
    Screen.Cursor := crDefault;
end;

end.

